﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using PokktXamarinSDK;
using Android.Util;

namespace PokktSample
{
	[Activity (Label = "VideoActivity")]			
	public class VideoActivity : Activity, IVideoDelegate
	{
		private string TAG = "PokktXamarinSample";
		private bool isAutoCaching = false;
		private Button btnPlayVideo;
		private Button btnPlayVideoNonIncent;

		protected override void OnCreate (Bundle bundle)
		{
			Log.Debug (TAG, "OnCreate called");
			RequestWindowFeature (WindowFeatures.NoTitle);
			base.OnCreate (bundle);

			// Create your application here
			SetContentView(Resource.Layout.Video);

			isAutoCaching = Intent.GetBooleanExtra ("auto_caching", false);
			PokktManagerHandler.VideoDelegate = this;
			PokktManagerHandler.SetActivity(this);//This method has to call very first time.
			PokktManagerHandler.SetDebug(true);
			//Mendatory to do this
			PokktManagerHandler.SetSecurityKey ("91f118562047d230f2b907ba93d2c4e2");
			PokktManagerHandler.SetApplicaionId ("4317fb1fcbf1ca98badf08ef59b0b86b");

			PokktManagerHandler.SetIntegrationType (0);
			PokktManagerHandler.SetAutoCacheVideo (isAutoCaching);
			testOpetionalMethods ();
			PokktManagerHandler.InitPokkt ();
			PokktManagerHandler.SendAppInfo ();

			Button btnStartCaching = FindViewById<Button> (Resource.Id.button_start_cache);
			btnStartCaching.Click += delegate 
			{
				checkVideoCache();
			};

			btnPlayVideo = FindViewById<Button> (Resource.Id.button_video);
			btnPlayVideo.Click += delegate 
			{
				((TextView) FindViewById(Resource.Id.points)).Text = "Points earned: ";
				PokktManagerHandler.SetScreenName("screenname");
				PokktManagerHandler.SetIncentivised(true);
				PokktManagerHandler.GetVideo();
			};

			btnPlayVideoNonIncent = FindViewById<Button> (Resource.Id.button_video_non_incent);
			btnPlayVideoNonIncent.Click += delegate 
			{
				((TextView) FindViewById(Resource.Id.points)).Text = "Points earned: ";
				PokktManagerHandler.SetScreenName("screenname");
				PokktManagerHandler.SetIncentivised(false);
				PokktManagerHandler.GetVideo();
			};

			if (isAutoCaching) {
				btnStartCaching.Visibility = ViewStates.Invisible;
			}

			if (PokktManagerHandler.IsVideoAvailablePokkt) {
				showButtons();
			}

			((TextView) FindViewById(Resource.Id.points)).Text = "Points earned: " + Storage.Points;
		}

		void testOpetionalMethods()
		{
			PokktManagerHandler.SetDefaultSkipTime (5);
			PokktManagerHandler.SetSkipEnabled (true);
			PokktManagerHandler.SetThirdPartyUserId ("1234");
			PokktManagerHandler.SetBackButtonDisabled (false);
			PokktManagerHandler.SetCustomSkipMessage ("Are you sure?");
			PokktManagerHandler.SetCloseOnSuccessFlag (true);

			PokktManagerHandler.SetAge ("32");
			PokktManagerHandler.SetBirthday ("20/08/1983");
			PokktManagerHandler.SetEducation ("MCA");
			PokktManagerHandler.SetEmailAddress ("pankaj454k@gmail.com");
			PokktManagerHandler.SetEmployment ("SE");
			PokktManagerHandler.SetFacebookId ("pankaj454k");
			PokktManagerHandler.SetLocation ("Bangalore");
			PokktManagerHandler.SetMaritalStatus ("Married");
			PokktManagerHandler.SetMaturityRating ("for all");
			PokktManagerHandler.SetMobileNo ("9900064040");
			PokktManagerHandler.SetName ("Pankaj");
			PokktManagerHandler.SetNationality ("Indian");
			PokktManagerHandler.SetSex ("Male");
			PokktManagerHandler.SetTwitterHandle ("pankaj454k");

			PokktManagerHandler.SetSelectedAnalyticsType (AnalyticsName.None);
		}

		void showButtons() {
			btnPlayVideo.Text = "Play Incent Vdo To Earn " + PokktManagerHandler.VideoVc;
			btnPlayVideo.Visibility = ViewStates.Visible;
			btnPlayVideoNonIncent.Visibility = ViewStates.Visible;
		}

		private void hideButtons() {
			btnPlayVideo.Visibility = ViewStates.Gone;
			btnPlayVideoNonIncent.Visibility = ViewStates.Gone;
		}

//		void updateUI(float points) {
//			((TextView) FindViewById(Resource.Id.points)).Text = "Points earned: " + points.ToString();
//			Log.Debug (TAG, "Received point : " + points);
//		}

		protected void checkVideoCache(){
			if (!PokktManagerHandler.IsVideoAvailablePokkt) {
				PokktManagerHandler.CacheVideoCampaign();
			}else{
				Toast.MakeText(this, "Video is already Available", ToastLength.Short).Show();
				showButtons();
			}
		}

		protected override void OnResume()
		{
			base.OnResume ();
			if (!PokktManagerHandler.IsVideoAvailablePokkt) {
				hideButtons ();
			}
		}

		protected override void OnDestroy()
		{
			Log.Debug (TAG, "onDestroy called");
			base.OnDestroy ();
		}

		void IVideoDelegate.OnDownloadCompleted(float vc)
		{
			Log.Debug (TAG, "Video Vc" + vc.ToString());
			showButtons ();
		}

		void IVideoDelegate.OnDownloadFailed()
		{
			Log.Debug (TAG, "Download failed");
		}

		void IVideoDelegate.OnVideoClosed()
		{
			Log.Debug (TAG, "Video Closed");
		}

		void IVideoDelegate.OnVideoCompleted()
		{
			Log.Debug (TAG, "Video Completed");
		}

		void IVideoDelegate.OnVideoDisplayed()
		{
			Log.Debug (TAG, "Video Displayed");
		}

		void IVideoDelegate.OnVideoGratified(string earnedPoints)
		{
			Log.Debug (TAG, earnedPoints);
			Storage.Points = earnedPoints;
			((TextView) FindViewById(Resource.Id.points)).Text = "Points earned: " + earnedPoints;
			//updateUI (float.Parse(earnedPoints));
		}

		void IVideoDelegate.OnVideoSkipped()
		{
			Log.Debug (TAG, "Video Skipped");
		}
	}
}

